/* $Id: gamereplay.hpp,v 1.3 2005/06/28 13:55:19 chfreund Exp $ */

#ifndef _GAMEREPLAY_HPP_
#define _GAMEREPLAY_HPP_

#include <fstream>
#include <SDL.h>
class World;
class Random;
class Player;
class String;
struct EchoMessage;

class GameReplay {
	public:
		enum RecordType {
			ECHO = 0,
			PLAYER_ENTER,
			PLAYER_QUIT,
			CHAT_MESSAGE,
			BOOKMARK
		};
	
	private:
		std::ofstream m_out;

	public:
		GameReplay( const char* filename, World* world, Random* random );
		~GameReplay();
		void addEcho( const EchoMessage& echo );
		void addPlayerEnter( const Player& player );
		void addPlayerQuit( Uint8 playerIndex );
		void addChatMessage( const String& message );
		void addBookmark();
};

#endif // _GAMEREPLAY_HPP_
