/* $Id: objectitem.hpp,v 1.5 2005/06/28 13:55:21 chfreund Exp $ */

#ifndef  _OBJECTITEM_HPP_
#define  _OBJECTITEM_HPP_

/**********************************************************/

#include "itemset.hpp"

/**********************************************************/

//! simple class to keep basic information for object initialization
class ObjectItem : public Item
{
	public:

		ObjectItem();
		virtual ~ObjectItem();

		//! \name member access
		//@{
		const Sint32 getObjectID() const { return m_ObjectID; }
		const Sint32 getX()        const { return m_x; }
		const Sint32 getY()        const { return m_x; }
		const Sint32 getDX()       const { return m_dx; }
		const Sint32 getDY()       const { return m_dx; }
		const Sint32 getVX()       const { return m_vx; }
		const Sint32 getVY()       const { return m_vx; }
		//@}

		//!
		virtual bool readFromSettings( SettingDataBase &settings,
		                               Sint32          &pos );

		//!
		static bool checkSettings( SettingDataBase &settings );
		//!
		static const SettingDef* getSettingDef() {
			return m_SettingDef; }

	protected:

		Sint32  m_ObjectID,
		        m_x,  m_y,
		        m_dx, m_dy,
		        m_vx, m_vy;

		static const SettingDef m_SettingDef[];
};

/**********************************************************/

typedef ItemSet<ObjectItem> ObjectSet;

/**********************************************************/

#endif // _OBJECTITEM_HPP_
