/* $Id: weaponmissile.hpp,v 1.7 2005/06/28 13:55:25 chfreund Exp $ */

#ifndef _WEAPONMISSILE_HPP_
#define _WEAPONMISSILE_HPP_

#include "weapon.hpp"
#include "missile.hpp"
#include "audio.hpp"

class WeaponMissile : public Weapon {
	public:
		WeaponMissile() {
			m_ID          = WEAPON_MISSILE;
			m_maximumAmmo =   4;
			m_reloadTime  =  15;
			m_chargeTime  = 100;
			rechargeNow();
			m_shotSample = Audio::getInstance()->loadSound( "sound/weapons/missile/launch.wav" );
			Missile::m_explodeSample = Audio::getInstance()->loadSound( "sound/effects/explosion1.wav" );
			Missile::m_damageSample = Audio::getInstance()->loadSound( "sound/effects/ricochet.wav" );
		}

		virtual bool reallyShoot( World* world, Avatar* avatar,
		                          const StationaryGun* gun = NULL ) const ;
};

#endif // _WEAPONMISSILE_HPP_
